package graphs;

import java.util.Collection;
import java.util.HashMap;

public class VertexSetCollection {

    HashMap<Vertex, Vertex> parentPointers;
    public VertexSetCollection(Collection<Vertex> vertices) {
        parentPointers = new HashMap<>();
        for (Vertex v : vertices) {
            parentPointers.put(v, null);
        }
    }

    public void UNION(Vertex a, Vertex b) {
        Vertex root1 = FIND(a);
        Vertex root2 = FIND(b);
        if (!root1.equals(root2)) {
            parentPointers.put(root1, root2);
        }
    }

    public Vertex FIND(Vertex v) {
        while (parentPointers.get(v) != null) {
            v = parentPointers.get(v);
        }
        return v;
    }
}
